/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2024  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.sql;

import de.steamwar.sql.internal.Field;
import de.steamwar.sql.internal.SelectStatement;
import de.steamwar.sql.internal.Statement;
import de.steamwar.sql.internal.Table;
import lombok.AllArgsConstructor;

import java.util.Set;
import java.util.stream.Collectors;

@AllArgsConstructor
public class Referee {

    private static final Table<Referee> table = new Table<>(Referee.class);
    private static final SelectStatement<Referee> byEvent = table.selectFields("eventID");

    private static final Statement insert = table.insertAll();
    private static final Statement delete = table.delete("eventReferee");

    public static void add(int eventID, int userID) {
        insert.update(eventID, userID);
    }

    public static void remove(int eventID, int userID) {
        delete.update(eventID, userID);
    }

    public static Set<Integer> get(int eventID) {
        return byEvent.listSelect(eventID).stream().map(referee -> referee.userID).collect(Collectors.toSet());
    }

    @Field(keys = {"eventReferee"})
    private final int eventID;
    @Field(keys = {"eventReferee"})
    private final int userID;
}
